%Matlab scripts for exercises 1 and 2

%Exercise 1

%a) US population
t=1790:2000;
p=310273000./(1+exp(-0.0353.*(t-1913.25)));
plot(t,p,'k--');
xlabel('Year $t$','Interpreter', 'latex');
ylabel('Population $P(t)$','Interpreter', 'latex');
title('US population')

%b) Subplot example
subplot(1,2,1)
[x,y]=meshgrid(-5:.5:5,-10:.5:10);
z=x.^2+2*sin(y);
surf(x,y,z);
xlabel('x-axis');
ylabel('y-axis');
zlabel('z-axis');

subplot(1,2,2)
contour(x,y,z)
xlabel('x-axis');
ylabel('y-axis');
axis square;

%c) Binomial and its normal approximation, requires statistics toolbox?
clf
N=7;
k=50;
p=0.25;
x=0:1:N;
probs = binopdf(x,N,p);
hold on
bar(x,probs)
xap=0:0.1:7;
approx = pdf('normal', xap, N*p, N*p*(1-p));
plot(xap,approx) %note: normal approxiation for binomial is generally not recommende unless N>20


%Exercise 2

%a)
A=[25 -25 15 1; 0 1 1 0; 1 -5 -3 -4; 1 0 0 -2];
b=[7 1 -16 0];
rank(A)
sol=A\b'; %or sol=inv(A)*b'

%b)
format long;
A=[1e-10 0.9 -0.4; 0 0.9 -0.4; 0  0 1e-10];
b=[0 0 1];
sol=A\b';
%condition number of matrix measures the sensitivity to errors
cond(A) %this is relatively large indicating that numerical errors are likely
%In this example having elements of different magnitude makes the matrix "badly scaled"
%The solution by hand is x_1=0;x_2=(4/9)10^{-10}, x_3=10^10

%c)
A=[0.3 0.6; 0.7 0.4];
[vecs,vals]=eig(A);
%identify the colums of vecs corresponding to eigenvalue 1 and scale it
stadist=vecs(:,2)./sum(vecs(:,2))
